<?php
/* restore a QuizSession
 * 
 * Copyright (C) 2007 Robert Bienert
 * <http://freihoch2.nerdbox.de/opensource/QuizSession/>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

require_once(dirname(__FILE__) . '/QuizSession.php');

class StoredQuizSession extends QuizSession {
	var $_answer;		// answer to the question

	var $_sidE;		// escaped session ID

	function StoredQuizSession() {
		$this->_sid	= $_POST['qs_id'];
		$this->_answer	= trim($_POST['qs_answer']);
		$this->_stored	= TRUE;

		$this->_sidE = mysql_real_escape_string($this->_sid);
	}

	// checks if the current sessions exists
	function exists() {
		$q = new Query('SELECT quiz_id, term1, term2'
				. ' FROM ' . QDTP . 'quiz_master' .
				" WHERE session_id='{$this->_sidE}'");
		if ($q->numRows() == -1)
			return FALSE;

		$r = $q->fetch();
		$this->_qid	= $r['quiz_id'];
		$this->_term1	= $r['term1'];
		$this->_term2	= $r['term2'];

		return TRUE;
	}

	// validates the session including validating the answer
	function validate() {
		if (! $this->exists()) {
			trigger_error('Invalid Session');
			return FALSE;
		}

		$q = new Query('SELECT answer FROM ' . QDTP .
				'quiz WHERE id=' .
				mysql_real_escape_string($this->_qid));
		$r = $q->fetch();

		// do some calculations
		if ($this->_term1 != 'NULL') {
			switch ($r['answer']) {
			case '+':
				$ans = $this->_term1 + $this->_term2;
				break;
			case '-':
				$ans = $this->_term1 - $this->_term2;
				break;
			case '*':
				$ans = $this->_term1 * $this->_term2;
				break;
			}

			return $ans == $this->_answer;
		}

		return $r['answer'] == $this->_answer;
	}

	// deletes the current session
	function cleanup() {
		$q = new Query('DELETE FROM ' . QDTP . 'quiz_master' .
				" WHERE session_id='{$this->_sidE}'");

		if ($q->error())
			trigger_error($q->getError(), E_USER_ERROR);
	}
}
?>
